package junit.extensions.eclipse.diff;

import org.eclipse.compare.CompareConfiguration;
import org.eclipse.compare.contentmergeviewer.IMergeViewerContentProvider;
import org.eclipse.jface.text.Document;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.swt.graphics.Image;

class JUnitDiffContentProvider implements IMergeViewerContentProvider {

    private CompareConfiguration fCompareConfiguration;

    public JUnitDiffContentProvider(CompareConfiguration cc) {
        fCompareConfiguration = cc;
    }

    public String getAncestorLabel(Object input) {
        return fCompareConfiguration.getAncestorLabel(input);
    }

    public Image getAncestorImage(Object input) {
        return fCompareConfiguration.getAncestorImage(input);
    }

    public Object getAncestorContent(Object input) {
        return null;
    }

    public boolean showAncestor(Object input) {
        return false;
    }

    public String getLeftLabel(Object input) {
        return "expected";
    }

    public Image getLeftImage(Object input) {
        return fCompareConfiguration.getLeftImage(input);
    }

    public Object getLeftContent(Object input) {
        if (input instanceof JUnitDiff) {
            return new Document(((JUnitDiff) input).getExpected());
        }
        return null;
    }

    public boolean isLeftEditable(Object input) {
        return false;
    }

    public void saveLeftContent(Object input, byte[] bytes) {
    }

    public String getRightLabel(Object input) {
        return "actual";
    }

    public Image getRightImage(Object input) {
        return fCompareConfiguration.getRightImage(input);
    }

    public Object getRightContent(Object input) {
        if (input instanceof JUnitDiff) {
            return new Document(((JUnitDiff) input).getActual());
        }
        return null;
    }

    public boolean isRightEditable(Object input) {
        return false;
    }

    public void saveRightContent(Object input, byte[] bytes) {
    }

    public void dispose() {
    }

    public void inputChanged(Viewer viewer, Object oldInput, Object newInput) {

    }
}